function getChunkId(ns,key,min) {
	var minValue = min;

	if (min === MinKey) {
		minValue = "MinKey";
	} else if (min === MaxKey) {
		minValue === "MaxKey";
	}

	if (min === parseInt(min,10)) {
		minValue = min + ".0";
	}

	return ns + "-" + key + "_" + minValue;
}

function getChunk(ns,key,shard,min,max,lastmodEpoch,time,inc) {

	var now = new Date();

	var chunk = {
		_id : getChunkId(ns,key,min),
		lastmod : new Timestamp(time,inc),
		lastmodEpoch : lastmodEpoch,
		ns : ns,
		min : {},
		max : {},
		shard : shard,
	};

	chunk.min[key] = min;
	chunk.max[key] = max;

	return chunk;
}

function createChunks(ns, key, shard, chunkCount) {

	var cns = db.serverStatus().sharding.configsvrConnectionString;
	// Tsk. Config servers don't accept batch requests. Prrft, we'll just ignore this, I think :)
	var configDB = connect(cns.substr(cns.indexOf('/') + 1) + "/config?replicaSet=" + cns.substr(0, cns.indexOf('/')));

	var chunk = configDB.chunks.findOne( { ns : ns });
	var lastmodEpoch = chunk.lastmodEpoch;
	var time = chunk.lastmod.getTime();
	var inc = chunk.lastmod.getInc();

	var bulk = configDB.chunks.initializeOrderedBulkOp();

	// Clear out all of the old chunks
	bulk.find( { ns : ns }).remove();

	inc++;

	// Create the first chunk
	bulk.insert( getChunk(ns, key, shard, MinKey, 1,lastmodEpoch,time,inc) );
	inc++;

	var startTime = new Date();

	for (var i = 1; i < chunkCount; i++) {
		// Create a "middle" chunk
		bulk.insert( getChunk(ns, key, shard, i, i+1,lastmodEpoch,time,inc) );
		inc++

		if (i%1000 == 0) {
			bulk.execute();
			bulk = configDB.chunks.initializeOrderedBulkOp();
			var endTime = new Date();
			var durationMs = endTime - startTime;
			print("Inserted " + i + " chunks. Last batch in " + durationMs + "ms.")
			startTime = new Date();
		}
	}

	// Create the last chunk
	bulk.insert( getChunk(ns, key, shard, chunkCount, MaxKey,lastmodEpoch,time,inc) );

	inc++;

	bulk.execute();	
}


var databaseName = "shardtest";
var collectionName = "testcoll";
var shardKey = "shardKey";
var shard = "shard0000";
var chunkCount = 450000;
var ns = databaseName + "." + collectionName;

var shardKeyDoc = {};
shardKeyDoc[shardKey] = 1;

sh.setBalancerState(false);
sh.stopBalancer();

// drop and recreate an empty collection with sharding enabled
db.getSiblingDB(databaseName)[collectionName].drop();
sh.enableSharding(databaseName);
sh.shardCollection(ns, shardKeyDoc, false);

// let's create us some chunks
createChunks(ns, shardKey, shard, chunkCount);

// Flush the mongos to reload the chunks
db.adminCommand("flushRouterConfig");
